	 SUBROUTINE CROWDINGDISTANCE
C     CALCULATES CROWDING DISTANCE FOR EACH FRONT'S MEMBER
       USE SHARED_DATA
	 IMPLICIT REAL*8(A-H,O-Z)
	 INTEGER::IND(POPNUM),MIND(POPNUM)
	 PARAMETER(F1MIN=0.0D0,F1MAX=1.0D0,F2MIN=0.0D0,F2MAX=1.0D0)
       DO I=1,MAXVAL(RANK)
	   K=0;IND=0
	   DO J=1,POPNUM
	      IF (RANK(J)==I) THEN
	          K=K+1
	          IND(K)=J
	      ENDIF
	   ENDDO
	   
	   DO II=1,K-1
	      DO JJ=1,K-1
	         IF (FITNESS1(IND(JJ+1))>FITNESS1(IND(JJ))) THEN
	             MIND(JJ)=IND(JJ)
	             IND(JJ)=IND(JJ+1)
	             IND(JJ+1)=MIND(JJ)
	         ENDIF
	      ENDDO
	   ENDDO
	   
	   DISTANCE(IND(1))=1.0D12; DISTANCE(IND(K))=1.0D12
	   
	   DO J=2,K-1
	      DISTANCE(IND(J))=DABS(FITNESS1(IND(J+1))-FITNESS1(IND(J-1))
	1	  )/(F1MAX-F1MIN)+DABS(FITNESS2(IND(J+1))-FITNESS2(IND(J-1)))
     1      /(F2MAX-F2MIN)
	   ENDDO
       ENDDO	
      
	END SUBROUTINE

