	 SUBROUTINE FINDNEWFITNESS(IGEN)
C	 ASSIGNES A FITNESS TO EACH POPULATION MEMBER
       USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
       IMPLICIT REAL*8(A-H,O-Z)
	 INCLUDE 'MPIF.H'
      
	 INTEGER::STATUS(MPI_STATUS_SIZE)
	 CHARACTER*2::EXT
	 CHARACTER*1::EXT2
	 WRITE(EXT,'(I2)') IRANK
       WRITE(EXT2,'(I1)') IRANK
	 
      
	 DO I=1,POPNUM
	    
		SUBMASS=0.0;SUBVIO=0.0;SUBEFF=0.0	    
	    TOTMASS=0.0;TOTVIO=0.0;TOTEFF=0.0
          AVEMASS=0.0;AVEVIO=0.0;AVEEFF=0.0
	    
	    IF (IRANK.NE.0) THEN

	       OPEN(12+IRANK,FILE='MOTOR'//EXT//'.INP')
             DO J=1,VARNUM
		   WRITE(12+IRANK,*) NEWCHROM2(I,J)  
		   ENDDO   
		   WRITE(12+IRANK,*) OUT_TORQUE
	       WRITE(12+IRANK,*) OUT_POWER
	       CLOSE(12+IRANK)  

              if (IRANK<10) then
				  CALL SYSTEM('runmotor'//EXT2//'.exe')
				  else
		CALL SYSTEM('runmotor'//EXT//'.exe')
		  endif

	       OPEN(13+IRANK,FILE='MOTOR'//EXT//'.OUT')
             READ(13+IRANK,*) MASS
	       READ(13+IRANK,*) EFF
	       READ(13+IRANK,*) LENGTH
             READ(13+IRANK,*) AWA
	       READ(13+IRANK,*) FEAS
	       READ(13+IRANK,*) H
	       CLOSE(13+IRANK)

	       
	
	       IF (EFF>1.0) EFF=EFF-INT(EFF)
	       IF (MASS<0) MASS=1.0D3
	       
		   CALL VIOLATION(VIO)
           
		   NEWFITNESS1(I)=5.0D-1*(EFF+(1.0D0-5.0D-1*MASS))-IGEN*VIO

		   CALL MPI_SEND(MASS,1,MPI_DOUBLE_PRECISION,0,1,
	1	                 MPI_COMM_WORLD,IERR)
             CALL MPI_SEND(EFF,1,MPI_DOUBLE_PRECISION,0,2,
	1                     MPI_COMM_WORLD,IERR)
	       CALL MPI_SEND(VIO,1,MPI_DOUBLE_PRECISION,0,3,
     1                     MPI_COMM_WORLD,IERR)
	       CALL MPI_RECV(VARIANCEINDEX,1,MPI_DOUBLE_PRECISION,0,IRANK
	1	                 ,MPI_COMM_WORLD,STATUS,IERR)

            
		   NEWFITNESS2(I)=VARIANCEINDEX/MAXCOMMONALITY-IGEN*VIO

	       IF (NEWFITNESS1(I)<0) NEWFITNESS1(I)=0.0
             IF (NEWFITNESS2(I)<0) NEWFITNESS2(I)=0.0  
	
	  ELSE
		   
	       DO II=1,P-1 
		     CALL MPI_RECV(SUBMASS,1,MPI_DOUBLE_PRECISION,II,1,
	1                       MPI_COMM_WORLD,STATUS,IERR)	
               CALL MPI_RECV(SUBEFF,1,MPI_DOUBLE_PRECISION,II,2,
	1                       MPI_COMM_WORLD,STATUS,IERR)
	         CALL MPI_RECV(SUBVIO,1,MPI_DOUBLE_PRECISION,II,3,
	1                       MPI_COMM_WORLD,STATUS,IERR)

	         TOTMASS=SUBMASS+TOTMASS
               TOTEFF=SUBEFF+TOTEFF
	         TOTVIO=SUBVIO+TOTVIO
             ENDDO

		   AVEMASS=TOTMASS/(P-1)
		   AVEEFF=TOTEFF/(P-1)
		   AVEVIO=TOTVIO/(P-1)	

	      
	       NEWFITNESS1(I)=5.0D-1*(AVEEFF+(1.0D0-5.0D-1*AVEMASS))-
	1	                       IGEN*AVEVIO

	       CALL NEWVARIANCE(I)
	       NEWFITNESS2(I)=VARIANCEINDEX/MAXCOMMONALITY-IGEN*AVEVIO
         
	       DO II=1,P-1
		      CALL MPI_SEND(VARIANCEINDEX,1,MPI_DOUBLE_PRECISION,II,II
	1		               ,MPI_COMM_WORLD,IERR)
             ENDDO
	 
		   IF (NEWFITNESS1(I)<0) NEWFITNESS1(I)=0.0
             IF (NEWFITNESS2(I)<0) NEWFITNESS2(I)=0.0
              

	     ENDIF
           
	 ENDDO
       
	 
 	 ENDSUBROUTINE


