        SUBROUTINE  RANDOM(IDUM,RND)
c
c  RETURNS A UNIFORM RANDOM DEVIATE BETWEEN 0.0 AND 1.0.  
c  THIS FUNCTION IF TAKEN FROM W.H. PRESS', "NUMERICAL RECIPES" P. 199.
c
       USE SHARED_DATA
	 IMPLICIT REAL*8 (A-H,M,O-Z)
       
       PARAMETER (MBIG=4000000.,MZ=0.,FAC=1./MBIG)
	 DIMENSION MA(55)
       DATA IFF /0/
       MSEED=1618033*(IRANK+1)
       IF (IDUM.LT.0 .OR. IFF.EQ.0) THEN
         IFF=1
         MJ=MSEED-DBLE(IABS(IDUM))
         MJ=DMOD(MJ,MBIG)
         MA(55)=MJ
         MK=1
         DO 11 I=1,54
            II=MOD(21*I,55)
            MA(II)=MK
            MK=MJ-MK
            IF(MK.LT.MZ) MK=MK+MBIG
            MJ=MA(II)
 11      CONTINUE
         DO 13 K=1,4
            DO 12 I=1,55
               MA(I)=MA(I)-MA(1+MOD(I+30,55))
               IF(MA(I).LT.MZ) MA(I)=MA(I)+MBIG
 12         CONTINUE
 13      CONTINUE
         INEXT=0
         INEXTP=31
         IDUM=1
       ENDIF
       INEXT=INEXT+1
       IF(INEXT.EQ.56) INEXT=1
       INEXTP=INEXTP+1
       IF(INEXTP.EQ.56) INEXTP=1
       MJ=MA(INEXT)-MA(INEXTP)
       IF(MJ.LT.MZ) MJ=MJ+MBIG
       MA(INEXT)=MJ
       RND=MJ*FAC
       RETURN

       END SUBROUTINE

