	 SUBROUTINE INITIALPOPULATION
C	 CREATE THE INITIAL RANDOM POPULATION IN ALL GAs
	 USE SHARED_DATA
	 USE UPPERLEVEL
	 USE LOWERLEVEL
       IMPLICIT REAL*8(A-H,O-Z)
	 INCLUDE 'MPIF.H' 

	 DO I=1,POPNUM
	   IF (IRANK==0) THEN
C      INITIALIZING 2D CHROMOSOMES IN THE UPPER LEVEL GA
	     DO J=1,VARNUM
	       DO K=1,PRONUM
	          CALL RANDOM(1,RND)
                IND1=INT(RND*PRONUM+1)
	          IF (IND1==PRONUM+1) IND1=PRONUM
	          IF (K>1) THEN
100	             DO II=1,K-1
	                IF (IND1==CHROM1(II,J,I)) THEN
	                   CALL RANDOM(1,RND)
	                   IND1=INT(RND*PRONUM+1)
	                   IF (IND1==PRONUM+1) IND1=PRONUM
                         GOTO 100
	                ENDIF
	             ENDDO
	          ENDIF
	          CHROM1(K,J,I)=IND1
	       ENDDO
	     ENDDO
	   ELSE
C      INITIALIZING 1D CHROMOSOMES IN ALL LOWER LEVEL GAs
	     DO J=1,VARNUM
	        CALL RANDOM(1,RND)
	        CHROM2(I,J)=RND*(RANGES(2,J)-RANGES(1,J))+RANGES(1,J)
	        IF (J<=2) THEN
			   CHROM2(I,J)=INT(CHROM2(I,J))
	        ELSE
			   CHROM2(I,J)=1.0D-3*INT(CHROM2(I,J)*1.D3+0.5)
              ENDIF
	     ENDDO
	   ENDIF
     	 ENDDO
	 

	 ENDSUBROUTINE 

