       SUBROUTINE NDSORTING
C     CONSTRAIN NON-DOMINATED SORTING OF A POPULATION APPLIED TO THE HIGHER LEVEL GA
       USE SHARED_DATA
	 IMPLICIT REAL*8(A-H,O-Z)
	 REAL*8::FITNESS11(POPNUM),FITNESS22(POPNUM)   	     
	 INTEGER::FRONT(POPNUM),SCRAP(POPNUM)
	 RANK=0;II=0
	 FITNESS11=FITNESS1;FITNESS22=FITNESS2
	 FRONT=0;SCRAP=0;FRONT(1)=1;IFRONT=0;IST=0
	 DO
	  IFRONT=IFRONT+1
	  K=1 
	  DO I=2,POPNUM
	   N=0
	   IF (FITNESS11(I).NE.1.0D12.AND.FITNESS22(I).NE.1.0D12.AND.I.NE.
	1   FRONT(1)) THEN
	   DO J=1,K
	     IF (FRONT(J).NE.0) THEN
	        IF (FITNESS11(I)>=FITNESS11(FRONT(J)).AND.FITNESS22(I)>=				
	1		    FITNESS22(FRONT(J))) THEN 
                  FRONT(J)=0
                  N=N+1
	        ELSEIF (FITNESS11(I)<=FITNESS11(FRONT(J)).AND.FITNESS22
	1		        (I)<=FITNESS22(FRONT(J))) THEN
	            EXIT
	        ELSE
	            N=N+1
	        ENDIF
	     ELSE
	        N=N+1
	     ENDIF
	   ENDDO
	   ENDIF
	
	   IF (N==K) THEN
	       FRONT(K+1)=I
	       K=K+1
	   ENDIF
	  ENDDO
	  DO I=1,POPNUM
	    IF (FRONT(I).NE.0) THEN
	       RANK(FRONT(I))=IFRONT
	       II=II+1
	    ENDIF
	  ENDDO
	  IF (II>=POPNUM) THEN
	     EXIT
	  ELSE
	     K=1 
	     DO I=1,POPNUM
	        IF (FRONT(I).NE.0) THEN
	            FITNESS11(FRONT(I))=1.0D12
	            FITNESS22(FRONT(I))=1.0D12
	            SCRAP(K+IST)=FRONT(I)
	            K=K+1
	        ENDIF
	     ENDDO
	
	     DO I=1,POPNUM 
	        COUNT=0
	        DO J=1,POPNUM
	           IF (SCRAP(J)==I) THEN
	               EXIT
	           ELSE
	               COUNT=COUNT+1
	           ENDIF
	        ENDDO
	        IF (COUNT==POPNUM) THEN
	           FRONT(1)=I
	           EXIT
	        ENDIF
	     ENDDO
	     FRONT(2:POPNUM)=0
	  ENDIF
	  IST=II
	 ENDDO
	
	 END SUBROUTINE


