       SUBROUTINE SETTARGET
C     SET THE TARGET AND LIMIT VALUES FOR RESPONSE VARIABLES
       USE SHARED_DATA
	 USE LOWERLEVEL
	 IMPLICIT REAL*8(A-H,O-Z)
       REAL*8::TRQ(PRONUM)
C      TARGETS 
       
	 OUT_POWER=3.0D2  !OUTPUT POWER

C      OUTPUT TORQUES FOR EACH MOTOR	 
	 TRQ(1)=5.0D-2 
	 TRQ(2)=0.1 
	 TRQ(3)=0.125 
	 TRQ(4)=0.15 
	 TRQ(5)=0.2 
	 TRQ(6)=0.25 
	 TRQ(7)=0.3 
	 TRQ(8)=0.35 
	 TRQ(9)=0.4 
	 TRQ(10)=0.5

	 IF (IRANK.NE.0) OUT_TORQUE=TRQ(IRANK)

C      LIMITS

       MAX_MASS=2.0D0
	 MIN_EFF=1.5D-1
	 MIN_FEAS=1.0D0
 	 MAX_H=5.0D3
	 MIN_AWA=1.0D-2
	 MAX_AWA=1.0D0
	 MIN_LENGTH=1.0D0
	 MAX_LENGTH=1.0D2


	 ENDSUBROUTINE
	 
