       SUBROUTINE VIOLATION(A)
C      DEFINES WHETHER EACH SOLUTION IS FEASIBLE AND ITS CONSTRAINT VIOLATION AMOUNT
       USE SHARED_DATA
	 USE LOWERLEVEL
	 IMPLICIT REAL*8(A-H,O-Z)
	 REAL*8::LENGTHVIO,MASSVIO
      
	 A=0.0
       MASSVIO=0.0;EFFVIO=0.0;HVIO=0.0
       AWAVIO=0.0;LENGTHVIO=0.0
       
	 IF (MASS>Max_MASS) MASSVIO=(1.0D0-ABS(Max_MASS/MASS))**2   	                      
       IF (EFF<Min_EFF) EFFVIO=(1.0D0-ABS(EFF)/Min_EFF)**2
       IF (H>MAX_H) HVIO=4*(1.0-ABS(MAX_H/H))**2
       IF (AWA<MIN_AWA) AWAVIO=4*(1.0D0-ABS(AWA)/MIN_AWA)**2
       IF (AWA>Max_AWA) AWAVIO=4*(1.0D0-Max_AWA/AWA)**2  
	 IF (LENGTH<MIN_LENGTH) LENGTHVIO=(1.0D0-ABS(LENGTH)/MIN_LENGTH)
	1                                   **2
       IF (LENGTH>Max_LENGTH) LENGTHVIO=(1.0D0-ABS(Max_LENGTH/LENGTH))
	1                                   **2  
	 
	 A=MASSVIO+EFFVIO+AWAVIO+LENGTHVIO+HVIO

	 ENDSUBROUTINE
 

















